/*
    Copyright (c) 2003, Stephane Sudre
	All rights reserved.

	Redistribution and use in source and binary forms, with or without modification, are permitted
    provided that the following conditions are met:

	Redistributions of source code must retain the above copyright notice, this list of conditions
    and the following disclaimer.

	Redistributions in binary form must reproduce the above copyright notice, this list of conditions
    and the following disclaimer in the documentation and/or other materials provided with the distribution.

	Neither the name of the WhiteBox nor the names of its contributors may be used to endorse 
    or promote products derived from this software without specific prior written permission.


	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR
    IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY 
    AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
    CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
    DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
    DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
    WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
    ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#import "AKServerModePaneController.h"
#import "CVSProcessEngine.h"

#define BUFFER_C		512

@implementation AKServerModePaneController

- (void) processWithEngine:(id) inEngine
{
    [inEngine setServerMode:[[IBmatrix_ selectedCell] tag]];
}

- (BOOL) checkPaneValuesWithEngine:(id) inEngine
{
    FILE * p=NULL;
    int tRecordCount=0;
    
    // To have this value set for AKStopPaneController
    
    [inEngine setServerMode:[[IBmatrix_ selectedCell] tag]];
    
    // Check that a pserver is not already running
    
    if ([[IBmatrix_ selectedCell] tag]==CVS_PSERVER)
    {
        p= popen("/usr/bin/niutil -list . /services | grep cvspserver","r");
    	
        if (p)
        {
            char tBuffer[BUFFER_C];
            
            while (fgets(tBuffer,BUFFER_C,p)!=0)
            {
                tRecordCount++;
            }
            
            if (pclose(p))
            {
                // Oh oh
            }
        }
        
        if (tRecordCount>0)
        {
            tRecordCount=0;
            
            p= popen("grep -v \"#\" /etc/inetd.conf | grep cvspserver","r");
            
            if (p)
            {
                char tBuffer[BUFFER_C];
                
                while (fgets(tBuffer,BUFFER_C,p)!=0)
                {
                    tRecordCount++;
                }
                
                if (pclose(p))
                {
                    // Oh oh
                }
            }
            
            if (tRecordCount>0)
            {
                NSBeginAlertSheet(NSLocalizedString(@"A CVS server with password authentication is already running on this computer.",@"No comment"),
                          nil,
                          nil,
                          nil,
                          [IBmatrix_ window],
                          self,
                          nil,
                          nil,
                          NULL,
                          NSLocalizedString(@"You don't need to create one.",@"No comment"));
                
                return NO;
            }
        }
    }
    
    return YES;
}

@end
