/*
    Copyright (c) 2003, Stephane Sudre
	All rights reserved.

	Redistribution and use in source and binary forms, with or without modification, are permitted
    provided that the following conditions are met:

	Redistributions of source code must retain the above copyright notice, this list of conditions
    and the following disclaimer.

	Redistributions in binary form must reproduce the above copyright notice, this list of conditions
    and the following disclaimer in the documentation and/or other materials provided with the distribution.

	Neither the name of the WhiteBox nor the names of its contributors may be used to endorse 
    or promote products derived from this software without specific prior written permission.


	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR
    IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY 
    AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
    CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
    DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
    DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, 
    WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
    ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

/*
            File Name: CVSProcessEngine.h
             Creation: 01/12/03
    Last modification: 01/12/03
    
    +----------+-------------+---------------------------------------------------------+
    |   Date   |    Author   | Comments                                                |
    +----------+-------------+---------------------------------------------------------+
    | 01/12/03 |   S.Sudre   | Creation                                                |
    +----------+-------------+---------------------------------------------------------+
    | 02/01/03 |   S.Sudre   | Fix: add the -d arguments. Without it the CVS DIR was   |
    |          |             |      always created in /Users/Shared/CVS                |
    +----------+-------------+---------------------------------------------------------+
    |          |             |                                                         |
    +----------+-------------+---------------------------------------------------------+
*/

#import "AKProcessEngine.h"
#import <Cocoa/Cocoa.h>

#define CVS_STANDARD_ACCOUNTS	0
#define CVS_CVS_ACCOUNTS		1

#define CVS_PSERVER			0
#define CVS_SSH_SERVER		1

@interface CVSProcessEngine : AKProcessEngine
{
    int serverMode_;
    int userAccountMode_;
    
    NSArray * usersArray_;
    
    NSString * repository_;
    
}

- (void) setServerMode:(int) inServerMode;
- (int) serverMode;

- (void) setUserAccountMode:(int) inUserAccountMode;
- (int) userAccountMode;

- (void) setUsersArray:(NSArray *) inUsersArray;
- (NSArray *) usersArray;

- (void) setRepository:(NSString *) inRepository;
- (NSString *) repository;

- (void) startProcess;

- (BOOL) endProcess;

- (BOOL) processPServer;
- (BOOL) processSSHServer;

@end
